/***********************************************************************

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

***********************************************************************/
package gecco.game.dke;

/**
 * DelayAction.java
 *
 *
 * Created: Wed Nov 27 15:34:05 2002
 *
 * @author <a href="mailto:Hans.Sandstrom@fhs.mil.se">Hans Sandstrm</a>
 * @version
 */

import gecco.server.core.*;


public abstract class DelayAction extends Action {

    double delay = 0;
    boolean firstRun = true;

    public DelayAction(){
	super();
    }

    /**
     * Use these constructor if you just want to throw the delay into the queue
     *
     * @param delay a <code>double</code> value
     */
    public DelayAction (int unitHandle, double delay){
	this();
	this.delay = delay;
	int actionHandle = gecco.server.core.Action.getNewActionHandle();
	initiate(actionHandle, unitHandle);
	ReferenceHolder.getActionProcessor().initiateAction(Def.getSystemRoleName(), this);
	setInstantaneous(false);
    }
    public DelayAction (int unitHandle, int argUnitHandle, double delay){
	this();
	this.delay = delay;
	int actionHandle = gecco.server.core.Action.getNewActionHandle();
	initiate(actionHandle, unitHandle, argUnitHandle);
	ReferenceHolder.getActionProcessor().initiateAction(Def.getSystemRoleName(), this);
	setInstantaneous(false);
    }

    public void initiate(int _actionHandle, int _unitHandle, int _argUnitHandle, double delay){
	super.initiate(_actionHandle, _unitHandle, _argUnitHandle);
	this.delay = (double)delay;
	setInstantaneous(false);
    }
    
}// DelayAction
